"use server";

import { requestGetFetch } from "@/utils/fetch";
import { Session } from "next-auth";
import { getServerSession } from "next-auth";
import { nextauthOptions } from "../nextauth-options";
import { SearchParams } from "@/types/searchParams";

export async function getProjects(searchParams?: SearchParams) {
  try {
    const session: Session = await getServerSession(nextauthOptions);
    const token = session?.user?.token;

    const paramsArray = searchParams && Object.entries(searchParams);

    const queryString = paramsArray && paramsArray.map(([key, value]) => `${key}=${value}`).join("&");

    const path = "v1/projects" + `?${queryString}`;
    const response = await requestGetFetch({
      path: path.toString(),
      options: {
        headers: {
          Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        cache: "no-store",
      },
    });
    return response;
  } catch (error) {
    if (error) {
    }
    throw error;
  }
}
